/* Definitions of target machine for GNU compiler.  Vxworks PowerPC 64bit
   version.
   Copyright (C) 2016 Free Software Foundation, Inc.
   Contributed by Douglas B Rupp

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 3, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

#undef TARGET_VXWORKS64
#define TARGET_VXWORKS64 1

#undef TARGET_64BIT
#define TARGET_64BIT 1

#undef DEFAULT_ABI
#define DEFAULT_ABI ABI_ELFv2

/* When the register allocator backs itself into a corner, it uses
   these macros to extract itself by stashing things in the GOT, however
   the diab linker wants to have total control of the GOT and rejects
   any such sections found in an object file. So we disable them.  */
#undef ASM_OUTPUT_SPECIAL_POOL_ENTRY
#undef ASM_OUTPUT_SPECIAL_POOL_ENTRY_P
#define ASM_OUTPUT_SPECIAL_POOL_ENTRY_P(X,Y) (0)

#undef DOT_SYMBOLS
#define DOT_SYMBOLS 0

#undef TARGET_CMODEL
#define TARGET_CMODEL CMODEL_MEDIUM

#undef CPP_SPEC
#define CPP_SPEC                        \
"%{!DCPU=*:                             \
   %{mcpu=603    : -DCPU=_VX_PPC603  ;  \
     mcpu=604    : -DCPU=_VX_PPC604  ;  \
     mcpu=8548   : -DCPU=_VX_PPCE500V2; \
     mcpu=e500mc : -DCPU=_VX_PPCE500MC; \
     mcpu=e6500  : -DCPU=_VX_PPCE6500;  \
                 : -DCPU=_VX_PPCE6500 }}" \
VXWORKS_ADDITIONAL_CPP_SPEC

#undef TARGET_OS_CPP_BUILTINS
#define TARGET_OS_CPP_BUILTINS()		\
  do						\
    {						\
      builtin_define ("__ppc");			\
      builtin_define ("__PPC__");		\
      builtin_define ("__PPC64__");		\
      builtin_define ("__powerpc__");		\
      builtin_define ("__powerpc64__");		\
      builtin_define ("__EABI__");		\
      builtin_define ("__ELF__");		\
      builtin_define ("__hardfp");		\
						\
      /* C89 namespace violation! */		\
      builtin_define ("CPU_FAMILY=PPC");	\
        					\
      VXWORKS_OS_CPP_BUILTINS ();		\
    }		\
  while (0)

/* We don't want --relax on 64bit because we always want -mlongcall.  */
#undef  LINK_SPEC
#define LINK_SPEC VXWORKS_LINK_SPEC

#undef  SIZE_TYPE
#define SIZE_TYPE ("long unsigned int")

#undef PTRDIFF_TYPE
#define PTRDIFF_TYPE ("long int")

#undef  WCHAR_TYPE
#define WCHAR_TYPE ("int")
#undef  WCHAR_TYPE_SIZE
#define WCHAR_TYPE_SIZE 32

#undef ASM_OUTPUT_BEFORE_CASE_LABEL
#define ASM_OUTPUT_BEFORE_CASE_LABEL(FILE, PREFIX, NUM, TABLE) \
  ASM_OUTPUT_ALIGN ((FILE), 3);

/* This definition is basically the same as can be found in
   crtstuff.c, but this target uses a custom crtbegin/crtend so
   it's not clear this is ever used.  */

#define CRT_CALL_STATIC_FUNCTION(SECTION_OP, FUNC)     \
static void __attribute__((used))                      \
call_ ## FUNC (void)                                   \
{                                                      \
   asm (SECTION_OP);                                   \
   FUNC ();                                            \
   FORCE_CODE_SECTION_ALIGN;                           \
   asm (TEXT_SECTION_ASM_OP);                          \
}

#undef STACK_CHECK_PROTECT
#define STACK_CHECK_PROTECT 16384
